// *** AUTOGENERATED FILE - Do not edit manually! - Changes will be overwritten! *** //

#include <inttypes.h>
#include <memory.h>
#include "generated/telecommands.h"
#include "generated/telemetry.h"
#include "objects/gpio.h"
#include "threads/telemetry.h"
#include "data/flash.h"


/**
 * Handle the telecommand to change a config item.
 *
 * @param config The config item to change.
 * @param value A pointer to the new value of the config item.
 */
static void handleCommandSetConfig(ConfigurationId configItem, const uint8_t* value) {
    Configuration* config = beginConfigUpdate();
    if (!config) {
        printError("Failed to update configuration: Failed start config update");
        return;
    }
    switch (configItem) {
    case PARACHUTE_TRIGGER_ALTITUDE:
        config->parachuteTriggerAltitude = *((const meter_t*) value);
        break;
    case PARACHUTE_TRIGGER_PRESSURE:
        config->parachuteTriggerPressure = *((const bar_t*) value);
        break;
    case ALTIMETER_MIN_POSSIBLE_VALUE:
        config->altimeterMinPossibleValue = *((const bar_t*) value);
        break;
    case ALTIMETER_MAX_POSSIBLE_VALUE:
        config->altimeterMaxPossibleValue = *((const bar_t*) value);
        break;
    case LANDED_PRESSURE_MIN:
        config->landedPressureMin = *((const bar_t*) value);
        break;
    case LANDED_PRESSURE_MAX_CHANGE:
        config->landedPressureMaxChange = *((const bar_t*) value);
        break;
    case STABLE_PRESSURE_LANDED_DURATION:
        config->stablePressureLandedDuration = *((const ms_t*) value);
        break;
    case RECOVERY_TELEMETRY_SEND_PERIOD:
        config->recoveryTelemetrySendPeriod = *((const ms_t*) value);
        break;
    case RECOVERY_TELEMETRY_LANDED_SEND_PERIOD:
        config->recoveryTelemetryLandedSendPeriod = *((const ms_t*) value);
        break;
    case RECOVERY_TELEMETRY_STAYING_ALIVE_SEND_PERIOD:
        config->recoveryTelemetryStayingAliveSendPeriod = *((const ms_t*) value);
        break;
    case STAY_ALIVE_TRIGGER_TIME:
        config->stayAliveTriggerTime = *((const ms_t*) value);
        break;
    case PARACHUTE_DEPLOY_TRIGGER_TIME:
        config->parachuteDeployTriggerTime = *((const ms_t*) value);
        break;
    case REQUIRED_CONSECUTIVE_PARACHUTE_DEPLOY_SENSOR_TIME:
        config->requiredConsecutiveParachuteDeploySensorTime = *((const ms_t*) value);
        break;
    case GPS_FAILED_INIT_WAIT_TIME:
        config->GPSFailedInitWaitTime = *((const ms_t*) value);
        break;
    case LANDED_MAX_ATTITUDE:
        config->landedMaxAttitude = *((const meter_t*) value);
        break;
    case LANDED_MAX_ATTITUDE_CHANGE:
        config->landedMaxAttitudeChange = *((const meter_t*) value);
        break;
    case STABLE_ATTITUDE_LANDED_DURATION:
        config->stableAttitudeLandedDuration = *((const ms_t*) value);
        break;
    case DETUMBLE_CONTROLLER_P:
        config->detumbleControllerP = *((const int16_t*) value);
        break;
    case DETUMBLE_CONTROLLER_I:
        config->detumbleControllerI = *((const int16_t*) value);
        break;
    case DETUMBLE_CONTROLLER_D:
        config->detumbleControllerD = *((const int16_t*) value);
        break;
    case ORIENTATION_CONTROLLER_P:
        config->orientationControllerP = *((const int16_t*) value);
        break;
    case ORIENTATION_CONTROLLER_I:
        config->orientationControllerI = *((const int16_t*) value);
        break;
    case ORIENTATION_CONTROLLER_D:
        config->orientationControllerD = *((const int16_t*) value);
        break;
    case USE_MOTOR_SPEEDS_FOR_CONTROLLER:
        config->useMotorSpeedsForController = *((const bool*) value);
        break;
    case HEARTBEAT_PERIOD:
        config->heartbeatPeriod = *((const ms_t*) value);
        break;
    case PRE_LAUNCH_IMU_CALIBRATION_TIME:
        config->preLaunchIMUCalibrationTime = *((const ms_t*) value);
        break;
    case PRE_LAUNCH_MOTOR_WARMUP_START_TIME:
        config->preLaunchMotorWarmupStartTime = *((const ms_t*) value);
        break;
    case PRE_LAUNCH_MOTOR_WARMUP_END_TIME:
        config->preLaunchMotorWarmupEndTime = *((const ms_t*) value);
        break;
    case MIN_ADCS_BATTERY_LEVEL:
        config->minADCSBatteryLevel = *((const volt_t*) value);
        break;
    case GOPRO_OFF_TIME:
        config->GoProOffTime = *((const ms_t*) value);
        break;
    case GOPRO_ON_TIME:
        config->GoProOnTime = *((const ms_t*) value);
        break;
    case EJECT_ADCS_START_WAIT_TIME:
        config->ejectADCSStartWaitTime = *((const ms_t*) value);
        break;
    case IMU_STATUS_CHECK_INTERVAL:
        config->IMUStatusCheckInterval = *((const ms_t*) value);
        break;
    case SD_CARD_CHECK_INTERVAL:
        config->SDCardCheckInterval = *((const ms_t*) value);
        break;
    case INITIAL_TELEMETRY_DELAY:
        config->initialTelemetryDelay = *((const ms_t*) value);
        break;
    default:
        printError("Got unknown config %u", (unsigned int) configItem);
    }
    commitConfigUpdate();
}

/**
 * Handle the telecommand to read a config item.
 *
 * @param config The config item to read.
 */
static void handleCommandGetConfig(ConfigurationId configItem, uint8_t* responseBuffer) {
    const Configuration* config = getConfig();
    switch (configItem) {
    case PARACHUTE_TRIGGER_ALTITUDE:
        memcpy(responseBuffer, (const uint8_t*) &config->parachuteTriggerAltitude,
            sizeof(config->parachuteTriggerAltitude));
        break;
    case PARACHUTE_TRIGGER_PRESSURE:
        memcpy(responseBuffer, (const uint8_t*) &config->parachuteTriggerPressure,
            sizeof(config->parachuteTriggerPressure));
        break;
    case ALTIMETER_MIN_POSSIBLE_VALUE:
        memcpy(responseBuffer, (const uint8_t*) &config->altimeterMinPossibleValue,
            sizeof(config->altimeterMinPossibleValue));
        break;
    case ALTIMETER_MAX_POSSIBLE_VALUE:
        memcpy(responseBuffer, (const uint8_t*) &config->altimeterMaxPossibleValue,
            sizeof(config->altimeterMaxPossibleValue));
        break;
    case LANDED_PRESSURE_MIN:
        memcpy(responseBuffer, (const uint8_t*) &config->landedPressureMin,
            sizeof(config->landedPressureMin));
        break;
    case LANDED_PRESSURE_MAX_CHANGE:
        memcpy(responseBuffer, (const uint8_t*) &config->landedPressureMaxChange,
            sizeof(config->landedPressureMaxChange));
        break;
    case STABLE_PRESSURE_LANDED_DURATION:
        memcpy(responseBuffer, (const uint8_t*) &config->stablePressureLandedDuration,
            sizeof(config->stablePressureLandedDuration));
        break;
    case RECOVERY_TELEMETRY_SEND_PERIOD:
        memcpy(responseBuffer, (const uint8_t*) &config->recoveryTelemetrySendPeriod,
            sizeof(config->recoveryTelemetrySendPeriod));
        break;
    case RECOVERY_TELEMETRY_LANDED_SEND_PERIOD:
        memcpy(responseBuffer, (const uint8_t*) &config->recoveryTelemetryLandedSendPeriod,
            sizeof(config->recoveryTelemetryLandedSendPeriod));
        break;
    case RECOVERY_TELEMETRY_STAYING_ALIVE_SEND_PERIOD:
        memcpy(responseBuffer, (const uint8_t*) &config->recoveryTelemetryStayingAliveSendPeriod,
            sizeof(config->recoveryTelemetryStayingAliveSendPeriod));
        break;
    case STAY_ALIVE_TRIGGER_TIME:
        memcpy(responseBuffer, (const uint8_t*) &config->stayAliveTriggerTime,
            sizeof(config->stayAliveTriggerTime));
        break;
    case PARACHUTE_DEPLOY_TRIGGER_TIME:
        memcpy(responseBuffer, (const uint8_t*) &config->parachuteDeployTriggerTime,
            sizeof(config->parachuteDeployTriggerTime));
        break;
    case REQUIRED_CONSECUTIVE_PARACHUTE_DEPLOY_SENSOR_TIME:
        memcpy(responseBuffer,
            (const uint8_t*) &config->requiredConsecutiveParachuteDeploySensorTime,
            sizeof(config->requiredConsecutiveParachuteDeploySensorTime));
        break;
    case GPS_FAILED_INIT_WAIT_TIME:
        memcpy(responseBuffer, (const uint8_t*) &config->GPSFailedInitWaitTime,
            sizeof(config->GPSFailedInitWaitTime));
        break;
    case LANDED_MAX_ATTITUDE:
        memcpy(responseBuffer, (const uint8_t*) &config->landedMaxAttitude,
            sizeof(config->landedMaxAttitude));
        break;
    case LANDED_MAX_ATTITUDE_CHANGE:
        memcpy(responseBuffer, (const uint8_t*) &config->landedMaxAttitudeChange,
            sizeof(config->landedMaxAttitudeChange));
        break;
    case STABLE_ATTITUDE_LANDED_DURATION:
        memcpy(responseBuffer, (const uint8_t*) &config->stableAttitudeLandedDuration,
            sizeof(config->stableAttitudeLandedDuration));
        break;
    case DETUMBLE_CONTROLLER_P:
        memcpy(responseBuffer, (const uint8_t*) &config->detumbleControllerP,
            sizeof(config->detumbleControllerP));
        break;
    case DETUMBLE_CONTROLLER_I:
        memcpy(responseBuffer, (const uint8_t*) &config->detumbleControllerI,
            sizeof(config->detumbleControllerI));
        break;
    case DETUMBLE_CONTROLLER_D:
        memcpy(responseBuffer, (const uint8_t*) &config->detumbleControllerD,
            sizeof(config->detumbleControllerD));
        break;
    case ORIENTATION_CONTROLLER_P:
        memcpy(responseBuffer, (const uint8_t*) &config->orientationControllerP,
            sizeof(config->orientationControllerP));
        break;
    case ORIENTATION_CONTROLLER_I:
        memcpy(responseBuffer, (const uint8_t*) &config->orientationControllerI,
            sizeof(config->orientationControllerI));
        break;
    case ORIENTATION_CONTROLLER_D:
        memcpy(responseBuffer, (const uint8_t*) &config->orientationControllerD,
            sizeof(config->orientationControllerD));
        break;
    case USE_MOTOR_SPEEDS_FOR_CONTROLLER:
        memcpy(responseBuffer, (const uint8_t*) &config->useMotorSpeedsForController,
            sizeof(config->useMotorSpeedsForController));
        break;
    case HEARTBEAT_PERIOD:
        memcpy(responseBuffer, (const uint8_t*) &config->heartbeatPeriod,
            sizeof(config->heartbeatPeriod));
        break;
    case PRE_LAUNCH_IMU_CALIBRATION_TIME:
        memcpy(responseBuffer, (const uint8_t*) &config->preLaunchIMUCalibrationTime,
            sizeof(config->preLaunchIMUCalibrationTime));
        break;
    case PRE_LAUNCH_MOTOR_WARMUP_START_TIME:
        memcpy(responseBuffer, (const uint8_t*) &config->preLaunchMotorWarmupStartTime,
            sizeof(config->preLaunchMotorWarmupStartTime));
        break;
    case PRE_LAUNCH_MOTOR_WARMUP_END_TIME:
        memcpy(responseBuffer, (const uint8_t*) &config->preLaunchMotorWarmupEndTime,
            sizeof(config->preLaunchMotorWarmupEndTime));
        break;
    case MIN_ADCS_BATTERY_LEVEL:
        memcpy(responseBuffer, (const uint8_t*) &config->minADCSBatteryLevel,
            sizeof(config->minADCSBatteryLevel));
        break;
    case GOPRO_OFF_TIME:
        memcpy(responseBuffer, (const uint8_t*) &config->GoProOffTime,
            sizeof(config->GoProOffTime));
        break;
    case GOPRO_ON_TIME:
        memcpy(responseBuffer, (const uint8_t*) &config->GoProOnTime, sizeof(config->GoProOnTime));
        break;
    case EJECT_ADCS_START_WAIT_TIME:
        memcpy(responseBuffer, (const uint8_t*) &config->ejectADCSStartWaitTime,
            sizeof(config->ejectADCSStartWaitTime));
        break;
    case IMU_STATUS_CHECK_INTERVAL:
        memcpy(responseBuffer, (const uint8_t*) &config->IMUStatusCheckInterval,
            sizeof(config->IMUStatusCheckInterval));
        break;
    case SD_CARD_CHECK_INTERVAL:
        memcpy(responseBuffer, (const uint8_t*) &config->SDCardCheckInterval,
            sizeof(config->SDCardCheckInterval));
        break;
    case INITIAL_TELEMETRY_DELAY:
        memcpy(responseBuffer, (const uint8_t*) &config->initialTelemetryDelay,
            sizeof(config->initialTelemetryDelay));
        break;
    default:
        printError("Got unknown config %u", (unsigned int) configItem);
    }
}

bool handleTelecommand(const TelecommandData* telecommand) {
    uint8_t responseBuffer[MAX_TELECOMMAND_RESPONSE_SIZE] = {0};
    switch (telecommand->command) {
    case COMMAND_SET_LAST_STATE: {
        SystemState state;
        memcpy(&state, &telecommand->data[0], sizeof(uint8_t));
        printDebug("Received SET_LAST_STATE(state=%" PRIu8 ")",
            (uint8_t) state);
        handleCommandSetLastState(state);
        break;
    }
    case COMMAND_GET_LAST_STATE: {
        printDebug("Received GET_LAST_STATE");
        SystemState lastState = handleCommandGetLastState();
        ((SystemState*) responseBuffer)[0] = lastState;
        sendTelemetryResponse(telecommand->counter, responseBuffer);
        return true;
    }
    case COMMAND_NEW_LOG_FILE: {
        printDebug("Received NEW_LOG_FILE");
        handleCommandNewLogFile();
        break;
    }
    case COMMAND_RESET_CHIP: {
        uint32_t verificationCode;
        memcpy(&verificationCode, &telecommand->data[0], sizeof(uint32_t));
        printDebug("Received RESET_CHIP(verificationCode=%" PRIu32 ")",
            verificationCode);
        handleCommandResetChip(verificationCode);
        break;
    }
    case COMMAND_SET_CURRENT_STATE: {
        SystemState state;
        memcpy(&state, &telecommand->data[0], sizeof(uint8_t));
        printDebug("Received SET_CURRENT_STATE(state=%" PRIu8 ")",
            (uint8_t) state);
        handleCommandSetCurrentState(state);
        break;
    }
    case COMMAND_GET_CURRENT_STATE: {
        printDebug("Received GET_CURRENT_STATE");
        SystemState state = handleCommandGetCurrentState();
        ((SystemState*) responseBuffer)[0] = state;
        sendTelemetryResponse(telecommand->counter, responseBuffer);
        return true;
    }
    case COMMAND_SET_FLIGHT: {
        uint32_t verificationCode;
        bool enable;
        memcpy(&verificationCode, &telecommand->data[0], sizeof(uint32_t));
        memcpy(&enable, &telecommand->data[4], sizeof(bool));
        printDebug("Received SET_FLIGHT(verificationCode=%" PRIu32 ", enable=%" PRIu8 ")",
            verificationCode, enable);
        handleCommandSetFlight(verificationCode, enable);
        break;
    }
    case COMMAND_GET_FLIGHT: {
        printDebug("Received GET_FLIGHT");
        bool flightMode = handleCommandGetFlight();
        ((bool*) responseBuffer)[0] = flightMode;
        sendTelemetryResponse(telecommand->counter, responseBuffer);
        return true;
    }
    case COMMAND_SET_PRE_LAUNCH_TIMER: {
        ms_t timer;
        memcpy(&timer, &telecommand->data[0], sizeof(ms_t));
        printDebug("Received SET_PRE_LAUNCH_TIMER(timer=%" PRIu32 ")",
            timer.ms);
        handleCommandSetPreLaunchTimer(timer);
        break;
    }
    case COMMAND_SET_VIDEO_ENABLED: {
        bool enabled;
        memcpy(&enabled, &telecommand->data[0], sizeof(bool));
        printDebug("Received SET_VIDEO_ENABLED(enabled=%" PRIu8 ")",
            enabled);
        handleCommandSetVideoEnabled(enabled);
        break;
    }
    case COMMAND_RESET_RECOVERY: {
        printDebug("Received RESET_RECOVERY");
        handleCommandResetRecovery();
        break;
    }
    case COMMAND_MOTOR_ENABLED: {
        bool enabled;
        memcpy(&enabled, &telecommand->data[0], sizeof(bool));
        printDebug("Received MOTOR_ENABLED(enabled=%" PRIu8 ")",
            enabled);
        handleCommandMotorEnabled(enabled);
        break;
    }
    case COMMAND_MOTOR_WARMUP: {
        bool enabled;
        memcpy(&enabled, &telecommand->data[0], sizeof(bool));
        printDebug("Received MOTOR_WARMUP(enabled=%" PRIu8 ")",
            enabled);
        handleCommandMotorWarmup(enabled);
        break;
    }
    case COMMAND_SET_CONFIG: {
        ConfigurationId config;
        const uint8_t* value;
        memcpy(&config, &telecommand->data[0], sizeof(uint8_t));
        value = &telecommand->data[1];
        printDebug("Received SET_CONFIG(config=%" PRIu8 ")",
            (uint8_t) config);
        handleCommandSetConfig(config, value);
        break;
    }
    case COMMAND_GET_CONFIG: {
        ConfigurationId config;
        memcpy(&config, &telecommand->data[0], sizeof(uint8_t));
        printDebug("Received GET_CONFIG(config=%" PRIu8 ")",
            (uint8_t) config);
        handleCommandGetConfig(config, responseBuffer);
        sendTelemetryResponse(telecommand->counter, responseBuffer);
        return true;
    }
    case COMMAND_SET_PWM: {
        pwm_t value;
        memcpy(&value, &telecommand->data[0], sizeof(pwm_t));
        static_assert(sizeof(double) == 8,
                "double has an invalid size on this platform and can not be used");
        printDebug("Received SET_PWM(value=%f)",
            value.pwm);
        if (getPin(TESTING_JUMPER_PIN) != HIGH) {
            printError("Received debug command but the testing pin is not set, ignoring it");
            return true;
        }
        handleCommandSetPwm(value);
        break;
    }
    case COMMAND_SET_RPM: {
        rpm_t value;
        memcpy(&value, &telecommand->data[0], sizeof(rpm_t));
        static_assert(sizeof(double) == 8,
                "double has an invalid size on this platform and can not be used");
        printDebug("Received SET_RPM(value=%f)",
            value.rpm);
        if (getPin(TESTING_JUMPER_PIN) != HIGH) {
            printError("Received debug command but the testing pin is not set, ignoring it");
            return true;
        }
        handleCommandSetRpm(value);
        break;
    }
    case COMMAND_SET_ADCS_MODE: {
        AdcsMode mode;
        memcpy(&mode, &telecommand->data[0], sizeof(uint8_t));
        printDebug("Received SET_ADCS_MODE(mode=%" PRIu8 ")",
            (uint8_t) mode);
        if (getPin(TESTING_JUMPER_PIN) != HIGH) {
            printError("Received debug command but the testing pin is not set, ignoring it");
            return true;
        }
        handleCommandSetAdcsMode(mode);
        break;
    }
    case COMMAND_DEPLOY_PARACHUTE: {
        printDebug("Received DEPLOY_PARACHUTE");
        if (getPin(TESTING_JUMPER_PIN) != HIGH) {
            printError("Received debug command but the testing pin is not set, ignoring it");
            return true;
        }
        handleCommandDeployParachute();
        break;
    }
    case COMMAND_SEND_IRIDIUM_MESSAGE: {
        printDebug("Received SEND_IRIDIUM_MESSAGE");
        if (getPin(TESTING_JUMPER_PIN) != HIGH) {
            printError("Received debug command but the testing pin is not set, ignoring it");
            return true;
        }
        handleCommandSendIridiumMessage();
        break;
    }
    case COMMAND_CALIBRATE_IMU: {
        uint8_t imu;
        memcpy(&imu, &telecommand->data[0], sizeof(uint8_t));
        printDebug("Received CALIBRATE_IMU(imu=%" PRIu8 ")",
            imu);
        if (getPin(TESTING_JUMPER_PIN) != HIGH) {
            printError("Received debug command but the testing pin is not set, ignoring it");
            return true;
        }
        bool calibrationResult = handleCommandCalibrateImu(imu);
        ((bool*) responseBuffer)[0] = calibrationResult;
        sendTelemetryResponse(telecommand->counter, responseBuffer);
        return true;
    }
    case COMMAND_SET_PAYLOAD_VIDEO: {
        bool enabled;
        memcpy(&enabled, &telecommand->data[0], sizeof(bool));
        printDebug("Received SET_PAYLOAD_VIDEO(enabled=%" PRIu8 ")",
            enabled);
        if (getPin(TESTING_JUMPER_PIN) != HIGH) {
            printError("Received debug command but the testing pin is not set, ignoring it");
            return true;
        }
        handleCommandSetPayloadVideo(enabled);
        break;
    }
    case COMMAND_SET_RECOVERY_STATE: {
        RecoveryState state;
        memcpy(&state, &telecommand->data[0], sizeof(uint8_t));
        printDebug("Received SET_RECOVERY_STATE(state=%" PRIu8 ")",
            (uint8_t) state);
        if (getPin(TESTING_JUMPER_PIN) != HIGH) {
            printError("Received debug command but the testing pin is not set, ignoring it");
            return true;
        }
        handleCommandSetRecoveryState(state);
        break;
    }
    default:
        return false;
    }
    sendTelemetryAcknowledge(telecommand->counter);
    return true;
}
